// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.internal.taglib;

import javax.faces.application.Application;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.component.UIReload;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/** 
 * JSP Tag class, generated from template {@code tag1.2.stg} with class 
 * {@link org.apache.myfaces.tobago.internal.taglib.component.ReloadTagDeclaration}.
 */
public final class ReloadTag extends TobagoELTag {
  private static final Logger LOG = LoggerFactory.getLogger(ReloadTag.class);
  private javax.el.ValueExpression  immediate;
  private javax.el.ValueExpression  update;
  private javax.el.ValueExpression  frequency;

  @Override
  public String getComponentType() {
    return UIReload.COMPONENT_TYPE;
  }
  @Override
  public String getRendererType() {
    return null;
  }

  @Override
  protected void setProperties(final UIComponent uiComponent) {
    super.setProperties(uiComponent);
    final UIReload component = (UIReload) uiComponent;
    final FacesContext context = FacesContext.getCurrentInstance();
    final Application application = context.getApplication();
    if (immediate != null) {
      if (!immediate.isLiteralText()) {
        component.setValueExpression("immediate", immediate);
      } else {
        component.setImmediate(Boolean.parseBoolean(immediate.getExpressionString()));
      }
    }
    if (update != null) {
      if (!update.isLiteralText()) {
        component.setValueExpression("update", update);
      } else {
        component.setUpdate(Boolean.parseBoolean(update.getExpressionString()));
      }
    }
    if (frequency != null) {
      if (!frequency.isLiteralText()) {
        component.setValueExpression("frequency", frequency);
      } else {
        component.setFrequency(Integer.parseInt(frequency.getExpressionString()));
      }
    }
  }

  public javax.el.ValueExpression getImmediate() {
    return immediate;
  }

  public void setImmediate(final javax.el.ValueExpression immediate) {
    this.immediate = immediate;
  }

  public javax.el.ValueExpression getUpdate() {
    return update;
  }

  public void setUpdate(final javax.el.ValueExpression update) {
    this.update = update;
  }

  public javax.el.ValueExpression getFrequency() {
    return frequency;
  }

  public void setFrequency(final javax.el.ValueExpression frequency) {
    this.frequency = frequency;
  }



  @Override
  public void release() {
    super.release();
    immediate = null;
    update = null;
    frequency = null;
  }
}